package com.bensleys.audiostreamer;

import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

// This SQLite class has been to created rather then defining SQLite access in all classes that require it
// so the DB is always accessed from this one central place
// Prop's to the chaps who wrote a tutorial from which I learn't to write this class! ...Who's names I have also forgotten :( sorry dudes
public class SQLite {

	// SQLite DB variables and interface containers
	private Context context;
	private DatabaseHelper DBHelper;
    public SQLiteDatabase db;
	
	// We shall pop two stations in by default when the DB is first created to show the end result and for testing
	public static final String DB_INITIAL_1 = "INSERT INTO " + GlobalVars.DB_TABLE + "(name, url, listens, duration) VALUES ('Future Radio', 'http://icecast.commedia.org.uk:8000/nr5.mp3', 0, 0);";
	public static final String DB_INITIAL_2 = "INSERT INTO " + GlobalVars.DB_TABLE + "(name, url, listens, duration) VALUES ('Reggae141', 'http://173.192.82.242:8002', 0, 0);";
	
	// This query is to set the single DB table up the first time the app is ever run
	private static final String CREATE_TABLE_SQL = "create table " + GlobalVars.DB_TABLE 
	+ " (id integer primary key autoincrement"
	+ ", name text not null"
	+ ", url text not null"
	+ ", listens integer"
	+ ", duration integer);";
	

    public SQLite(Context ctx) 
    {
        this.context = ctx;
        DBHelper = new DatabaseHelper(context);
    }
        
    private static class DatabaseHelper extends SQLiteOpenHelper 
    {
        DatabaseHelper(Context context) 
        {
            super(context, GlobalVars.DB_NAME, null, GlobalVars.DB_VERSION);
        }

        @Override
        public void onCreate(SQLiteDatabase db) 
        {
            db.execSQL(CREATE_TABLE_SQL); // Create the initial DB layout
            db.execSQL(DB_INITIAL_1); // Create our test stations
            db.execSQL(DB_INITIAL_2);
        }

        @Override
        public void onUpgrade(SQLiteDatabase db, int oldVersion, 
                              int newVersion) 
        {
            db.execSQL("DROP TABLE IF EXISTS " + GlobalVars.DB_TABLE);
            onCreate(db);
        }
    } 
    
    // Open the database
    public SQLite open() throws SQLException 
    {
        db = DBHelper.getWritableDatabase();
        return this;
    }

    // Close the database   
    public void close() 
    {
        DBHelper.close();
    }

    // Retrieves all the stations
    public Cursor getAllStations() 
    {
        return db.query(GlobalVars.DB_TABLE, new String[] { 
        		"id", "name", "url", "listens", "duration"},
                null, null, null, null, null);
    }
}
