package com.bensleys.audiostreamer;

import java.io.IOException;
import java.util.Timer;
import java.util.TimerTask;

import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.media.MediaPlayer;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.util.Log;

public class StreamService extends Service {
	
	// Streaming variables & objects
	public static Integer INT_PLAY_STATE=0;
	public Integer INT_DURATION_MILLIS;
	public Integer INT_DURATION_SECONDS;
	public Integer INT_DURATION_MINUTES;
	
	public static Timer TMR_DURATION;
	public static Timer TMR_CONNECT;
	public static Thread THD_MPLAYER;
	MediaPlayer CLS_MPLAYER = new MediaPlayer();
	
	public static boolean BOL_ONLINE = false;
	
	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}
	
	@Override
	public void onStart(Intent intent, int startid) {
		if(isOnline()){
			AudioStreamer.TXT_STATION.setText(GlobalVars.STR_STATION);
			AudioStreamer.TXT_DURATION.setText(R.string.strConnecting);
		
			INT_DURATION_MILLIS = 0;
			INT_DURATION_SECONDS = 0;
			INT_DURATION_MINUTES = 0;
			StreamService.THD_MPLAYER = new Thread() {
				public void run() {
					try {
						CLS_MPLAYER.setDataSource(GlobalVars.STR_URL.toString());
	    	    	} catch (IllegalArgumentException e) {
	    	    		//e.printStackTrace();
	    	    	} catch (IllegalStateException e) {
	    	    		//e.printStackTrace();
	    	    	} catch (IOException e) {
	    	    		//e.printStackTrace();
	    	    	}
	    	    	try {
	    	    		CLS_MPLAYER.prepare();
	    	    	} catch (IOException e) {
	    	    		//e.printStackTrace();
	    	    	} catch (IllegalStateException e) {
	    	    		//e.printStackTrace();
	    	    	}
	    	    	CLS_MPLAYER.start();
				}
			
			};
			StreamService.THD_MPLAYER.start();
		
			StreamService.TMR_DURATION = new Timer();
			StreamService.TMR_DURATION.schedule(new ttDuration(), 200, 200);
		
			StreamService.TMR_CONNECT = new Timer();
			StreamService.TMR_CONNECT.schedule(new ttConnected(), 8000, 8000);
		
			INT_PLAY_STATE=1;
		
			AudioStreamer.BTN_LISTEN.setText(R.string.strStop);
		
		}// isOnline() check
	}

	@Override
	public void onDestroy() {
		AudioStreamer.TXT_DURATION.setText("");
		AudioStreamer.BTN_LISTEN.setText(R.string.strPlay);
		StreamService.TMR_DURATION.cancel();
		StreamService.TMR_CONNECT.cancel();
		CLS_MPLAYER.stop();
		CLS_MPLAYER.reset();
		StreamService.THD_MPLAYER = null;
		INT_PLAY_STATE=0;
	}
    
    class ttDuration extends TimerTask
    {
            @Override
            public void run()
            {
            	hdrDuration.sendEmptyMessage(0);
            }
    }
    
    Handler hdrDuration = new Handler()
    {
    	@Override
    	public void handleMessage(Message m)
    	{
    		if(CLS_MPLAYER.isPlaying() == true)
    		{
    			INT_DURATION_MILLIS+=200;
    			if(INT_DURATION_MILLIS>=1000){
    				INT_DURATION_MILLIS=0;
    				INT_DURATION_SECONDS++;
    				if(INT_DURATION_SECONDS>=60) {
    					INT_DURATION_MINUTES++;
    					INT_DURATION_SECONDS=0;
    				}
    				if(INT_DURATION_SECONDS<10){
    					AudioStreamer.TXT_DURATION.setText(Integer.toString(INT_DURATION_MINUTES)+":0"+Integer.toString(INT_DURATION_SECONDS));
    				}else{           	
    					AudioStreamer.TXT_DURATION.setText(Integer.toString(INT_DURATION_MINUTES)+":"+Integer.toString(INT_DURATION_SECONDS));
    				}
    			}
    		}
    	}
    };

    
    class ttConnected extends TimerTask
    {
    	@Override
        public void run()
        {
    		hdrConnected.sendEmptyMessage(0);
    	}
    }
    
    Handler hdrConnected = new Handler()
    {
    	@Override
    	public void handleMessage (Message m)
    	{
    		if(CLS_MPLAYER.isPlaying() == false)
        	{
    			if(isOnline()==true){
    				AudioStreamer.TXT_DURATION.setText(R.string.strConnecting);
    				CLS_MPLAYER.reset();
    				StreamService.THD_MPLAYER = null;
    				StreamService.THD_MPLAYER = new Thread() {
    					public void run() {
    						try {
    		    	    		CLS_MPLAYER.setDataSource(GlobalVars.STR_URL.toString());
    		    	    	} catch (IllegalArgumentException e) {
    		    	    	} catch (IllegalStateException e) {
    		    	    	} catch (IOException e) {
    		    	    	}
    		    	    	try {
    		    	    		CLS_MPLAYER.prepare();
    		    	    	} catch (IOException e) {
    		    	    	} catch (IllegalStateException e) {
    		    	    	}
    		    	    	CLS_MPLAYER.start();
    		    	    	Log.d("here: ", "trying to start() mplayer");
    					}
    				};
    				StreamService.THD_MPLAYER.start();
    			}else{ // isOnline()
    				AudioStreamer.TXT_DURATION.setText(R.string.strUnavailble);
    			}
        	}// CLS_MPLAYER.isPlaying()
    	}
    };
    
    public boolean isOnline() { // Method to check if a network connection is detected, returns true if so;
        ConnectivityManager connectivityManager = (ConnectivityManager)getApplicationContext().getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo networkInfo = connectivityManager.getActiveNetworkInfo();
        boolean connected = networkInfo != null && networkInfo.isAvailable() && networkInfo.isConnected();
        return connected;
    }

}
